<div *ngIf="entries != null">
  <form [ngFormModel]="forming">
    <div class="mdc-layout-grid">
      <div class="grid-inner">
        <div
          *ngFor="let entry of entries; let i = index"
          [ngClass]="classFor(entry)"
        >
          <div *ngIf="isConflict(entry)">
            <label for="entry.id">
              {{ entry.id }}
              <br />
            </label>
            <material-dropdown-select
              [id]="entry.id"
              [ngControl]="entry.id"
              [buttonText]="buttonTextForDropdown(entry.id)"
              [options]="entry.suggestions"
              [error]="isUnresolvedConflict(entry) ? 'You must make a selection' : null"
            >
            </material-dropdown-select>
          </div>

          <div *ngIf="!isConflict(entry)" [ngSwitch]="entry.rule.ruleType">
            <div *ngSwitchCase="RuleType.text">
              <material-input
                *ngIf="entry.suggestions == null"
                class="block-width"
                [ngClass]="classForInput(entry)"
                floatingLabel
                multiline
                [autoFocus]="i == 0"
                [required]="entry.rule.isMandatory"
                [disabled]="readonly || entry.disabled"
                type="text"
                [maxCount]="
                  entry.rule.characterLimit == 0 || readonly
                    ? null
                    : entry.rule.characterLimit
                "
                [id]="entry.id"
                [ngControl]="entry.id"
                [value]="entry.originalValue"
                [label]="entry.id"
              >
                <auto-form-tooltip
                  *ngIf="shouldShowTooltip(entry)"
                  trailing
                  [status]="entry.status"
                  [message]="tooltipFor(entry)"
                >
                </auto-form-tooltip>
              </material-input>

              <material-auto-suggest-input
                *ngIf="entry.suggestions != null"
                [ngClass]="classForInput(entry)"
                floatingLabel
                multiline
                [autoFocus]="i == 0"
                [required]="entry.rule.isMandatory"
                [disabled]="readonly || entry.disabled"
                [maxCount]="
                  entry.rule.characterLimit == 0 || readonly
                    ? null
                    : entry.rule.characterLimit
                "
                [id]="entry.id"
                [ngControl]="entry.id"
                [inputText]="entry.originalValue"
                [label]="entry.id"
                [selectionOptions]="entry.suggestions"
              >
              </material-auto-suggest-input>
            </div>

            <material-input
              *ngSwitchCase="RuleType.number"
              floatingLabel
              type="number"
              [required]="entry.rule.isMandatory"
              [disabled]="readonly || entry.disabled"
              checkPositive
              [lowerBound]="0"
              [id]="entry.id"
              [ngControl]="entry.id"
              [value]="entry.originalValue"
              [label]="entry.id"
            >
            </material-input>

            <material-toggle
              *ngSwitchCase="RuleType.toggle"
              [checked]="entry.originalValue ?? false"
              [disabled]="readonly || entry.disabled"
              [id]="entry.id"
              [ngControl]="entry.id"
              [label]="entry.id"
            >
            </material-toggle>

            <div>
              <label *ngSwitchCase="RuleType.dropdown" for="entry.id">
                {{ entry.id }}
                <br />
              </label>
              <material-dropdown-select
                *ngSwitchCase="RuleType.dropdown"
                [id]="entry.id"
                [ngControl]="entry.id"
                [label]="entry.id"
                [buttonText]="buttonTextForDropdown(entry.id)"
                [options]="entry.suggestions"
              >
              </material-dropdown-select>
            </div>
          </div>
          <!-- <div [ngSwitch]="entry.rule.ruleType"> -->
        </div>
        <!-- <div *ngFor="let entry of entries; let i=index"> -->

        <div class="mdc-layout-grid__cell--span-12">
          <ng-content></ng-content>
        </div>

        <div
          *ngIf="shouldShowAction"
          class="mdc-layout-grid__cell--span-12 action-bar"
        >
          <material-button
            raised
            *ngIf="canBeDelete"
            class="red"
            (trigger)="onDelete()"
          >
            {{ deleteButtonLabel }}
          </material-button>

          <material-button
            raised
            class="yellow"
            [disabled]="!cancelAlwaysOn && !isChanged"
            (trigger)="onCancel()"
          >
            {{ cancelButtonLabel }}
          </material-button>

          <material-button
            raised
            class="blue"
            [disabled]="!isChanged"
            (trigger)="onSubmit()"
          >
            {{ submitButtonLabel }}
          </material-button>
        </div>
        <!-- <div *ngIf="shouldShowAction" -->
      </div>
      <!-- <div class="grid-inner"> -->
    </div>
    <!-- div class="mdc-layout-grid">  -->
  </form>
</div>
